unit Unit1;
(*--------------------------------------------------------------------*)
(*      MAMAVISION Software Consult                                   *)
(*--------------------------------------------------------------------*)
(*      'Data' Formclass which is cloned.                             *)
(*      Contains group of Dummy components which 'root' class needs   *)
(*      or might need in the future.                                  *)
(*      When IDE supports form inheritance the Dummy Controls can     *)
(*      be deleted.                                                   *)
(*                                                                    *)
(*--------------------------------------------------------------------*)
(*      Subclassing:                                                  *)
(*		  TForm --> TForm0 --> TForm1                                   *)
(**********************************************************************)
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, RootForm, ExtCtrls, Buttons;

  { The group of Control Dummies is necessary ! For each Controlclass
    which is loaded from TForm0's resource their must be a class member
    in TForm1 otherwise RTF and resource not loaded }
type
  TForm1 = class(TForm0)
    Label1: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    Dummy_Panel: TPanel;
    Dummy_Speedbutton: TSpeedButton;
    Dummy_Bevel: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure Button1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadRes;
end;

procedure TForm1.Button1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Statusbar.Caption := 'Button1(TForm1) activates Statusbar(TForm0)';
end;

procedure TForm1.Button1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Statusbar.Caption := 'ready';
end;

end.
