unit Benpow;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, Buttons, ColorGrd, Menus, Printers, ClipBrd, Dialogs,
  ExtCtrls, MPlayer;

type
  TDrawingTool = (dtLine, dtRectangle, dtEllipse, dtRoundRect);

  TForm2 = class(TForm)
    ToolBar: TPanel;
    LineButton: TSpeedButton;
    RectangleButton: TSpeedButton;
    EllipseButton: TSpeedButton;
    RoundRectButton: TSpeedButton;
    PenButton: TSpeedButton;
    BrushButton: TSpeedButton;
    PenBar: TPanel;
    BrushBar: TPanel;
    SolidPen: TSpeedButton;
    DashPen: TSpeedButton;
    DotPen: TSpeedButton;
    DashDotPen: TSpeedButton;
    DashDotDotPen: TSpeedButton;
    ClearPen: TSpeedButton;
    SolidBrush: TSpeedButton;
    ClearBrush: TSpeedButton;
    HorizontalBrush: TSpeedButton;
    VerticalBrush: TSpeedButton;
    FDiagonalBrush: TSpeedButton;
    BDiagonalBrush: TSpeedButton;
    CrossBrush: TSpeedButton;
    DiagCrossBrush: TSpeedButton;
    PenColor: TColorGrid;
    BrushColor: TColorGrid;
    PenWidth: TScrollBar;
    PenSize: TLabel;
    StatusBar: TPanel;
    OriginPanel: TPanel;
    CurrentPanel: TPanel;
    ScrollBox1: TScrollBox;
    Image: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Cut1: TMenuItem;
    book: TSpeedButton;
    OpenDialog2: TOpenDialog;
    paint: TSpeedButton;
    View1: TMenuItem;
    MaxZoom1: TMenuItem;
    Image1: TImage;
    About1: TMenuItem;
    zoomin: TSpeedButton;
    zoomout: TSpeedButton;
    aces: TSpeedButton;
    Dinosony: TMediaPlayer;
    Musicbar: TPanel;
    nature11: TSpeedButton;
    nature12: TSpeedButton;
    nature10: TSpeedButton;
    nature8: TSpeedButton;
    nature6: TSpeedButton;
    nature5: TSpeedButton;
    nature4: TSpeedButton;
    SpeedButton8: TSpeedButton;
    nature1: TSpeedButton;
    nature3: TSpeedButton;
    nature9: TSpeedButton;
    nature7: TSpeedButton;
    Label1: TLabel;
    natrue2: TSpeedButton;
    dinsor2: TSpeedButton;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure LineButtonClick(Sender: TObject);
    procedure RectangleButtonClick(Sender: TObject);
    procedure EllipseButtonClick(Sender: TObject);
    procedure RoundRectButtonClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PenButtonClick(Sender: TObject);
    procedure BrushButtonClick(Sender: TObject);
    procedure PenWidthChange(Sender: TObject);
    procedure SetPenStyle(Sender: TObject);
    procedure PenColorClick(Sender: TObject);
    procedure SetBrushStyle(Sender: TObject);
    procedure BrushColorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure bookClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure paintClick(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure MaxZoom1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure dsou1Click(Sender: TObject);
    procedure natrue2Click(Sender: TObject);
    procedure nature5Click(Sender: TObject);
    procedure nature1Click(Sender: TObject);
    procedure nature3Click(Sender: TObject);
    procedure nature4Click(Sender: TObject);
    procedure nature6Click(Sender: TObject);
    procedure nature7Click(Sender: TObject);
    procedure nature8Click(Sender: TObject);
    procedure nature9Click(Sender: TObject);
    procedure nature10Click(Sender: TObject);
    procedure nature11Click(Sender: TObject);
    procedure nature12Click(Sender: TObject);
    procedure acesClick(Sender: TObject);
    procedure dinsor2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Drawing: Boolean;
    Origin, MovePt: TPoint;
    DrawingTool: TDrawingTool;
    CurrentFile: string;
    procedure DrawShape(TopLeft, BottomRight: TPoint; AMode: TPenMode);
  end;

var
  Form2: TForm2;
  F:tEXTfILE;
  T:CHAR;
  dire:String;
  c:Boolean;
implementation

uses BMPDlg,Bookc,about;

{$R *.DFM}

procedure TForm2.LineButtonClick(Sender: TObject);
begin
  DrawingTool := dtLine;
end;

procedure TForm2.RectangleButtonClick(Sender: TObject);
begin
  DrawingTool := dtRectangle;
end;

procedure TForm2.EllipseButtonClick(Sender: TObject);
begin
  DrawingTool := dtEllipse;
end;

procedure TForm2.RoundRectButtonClick(Sender: TObject);
begin
  DrawingTool := dtRoundRect;
end;

procedure TForm2.DrawShape(TopLeft, BottomRight: TPoint; AMode: TPenMode);
begin
  with Image.Canvas do
  begin
    Pen.Mode := AMode;
    case DrawingTool of
      dtLine: begin
                MoveTo(TopLeft.X, TopLeft.Y);
                LineTo(BottomRight.X, BottomRight.Y);
              end;
      dtRectangle: Rectangle(TopLeft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);
      dtEllipse: Ellipse(TopLeft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);
      dtRoundRect: RoundRect(TopLeft.X, TopLeft.Y, BottomRight.X, BottomRight.Y,
        (TopLeft.X - BottomRight.X) div 2, (TopLeft.Y - BottomRight.Y) div 2);
    end;
  end;
end;

procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If paint.Down=True then
     begin
     Image.Canvas.Brush.Color:=BrushColor.ForegroundColor;
     Image.Canvas.FloodFill(x,y,clBlack,fsBorder);
     end;
  If Paint.Down=false then
  begin
  Drawing := True;
  Image.Canvas.MoveTo(X, Y);
  Origin := Point(X, Y);
  MovePt := Origin;
  OriginPanel.Caption := Format('Origin: (%d, %d)', [X, Y]);
  end;
end;

procedure TForm2.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Drawing then
    DrawShape(Origin, Point(X, Y), pmCopy);
  Drawing := False;
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Drawing then
  begin
    DrawShape(Origin, MovePt, pmNotXor);
    MovePt := Point(X, Y);
    DrawShape(Origin, MovePt, pmNotXor);
  end;
  CurrentPanel.Caption := Format('Current: (%d, %d)', [X, Y]);
end;

procedure TForm2.PenButtonClick(Sender: TObject);
begin
  PenBar.Visible := PenButton.Down;
end;

procedure TForm2.BrushButtonClick(Sender: TObject);
begin
  BrushBar.Visible := BrushButton.Down;
end;

procedure TForm2.PenWidthChange(Sender: TObject);
begin
  Image.Canvas.Pen.Width := PenWidth.Position;
  PenSize.Caption := IntToStr(PenWidth.Position);
end;

procedure TForm2.SetPenStyle(Sender: TObject);
begin
  with Image.Canvas.Pen do
  begin
    if Sender = SolidPen then Style := psSolid
    else if Sender = DashPen then Style := psDash
    else if Sender = DotPen then Style := psDot
    else if Sender = DashDotPen then Style := psDashDot
    else if Sender = DashDotDotPen then Style := psDashDotDot
    else if Sender = ClearPen then Style := psClear;
  end;
end;

procedure TForm2.PenColorClick(Sender: TObject);
begin
  Image.Canvas.Pen.Color := PenColor.ForegroundColor;
end;

procedure TForm2.SetBrushStyle(Sender: TObject);
begin
  with Image.Canvas.Brush do
  begin
    if Sender = SolidBrush then Style := bsSolid
    else if Sender = ClearBrush then Style := bsClear
    else if Sender = HorizontalBrush then Style := bsHorizontal
    else if Sender = VerticalBrush then Style := bsVertical
    else if Sender = FDiagonalBrush then Style := bsFDiagonal
    else if Sender = BDiagonalBrush then Style := bsBDiagonal
    else if Sender = CrossBrush then Style := bsCross
    else if Sender = DiagCrossBrush then Style := bsDiagCross;
  end;
end;

procedure TForm2.BrushColorClick(Sender: TObject);
begin
     Image.Canvas.Brush.Color:=BrushColor.ForegroundColor;
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  Bitmap: TBitmap;
  f2:TextFile;
  count:integer;
  SearchRec:TSearchRec;
begin
    c:=true;
    dire:='d:\power\source21';
    if FindFirst(dire+'\Power1.exe', faAnyFile, SearchRec)<>0 then
    While FindFirst(dire+'\Power1.exe', faAnyFile, SearchRec)<>0 do
          begin
          Findclose(SearchRec);
          if inputquery('File error','Please enter new path for Dinso.exe',dire)=false
             then halt;
          End;
  AssignFile(f2,'c:\c1.c');
  Rewrite(f2);
  Write(f2,dire);
  closefile(f2);
  assignFile(f,'c:\c.c');
  {$I-}
  reset(f);
  {$I+}
  If IOResult<>0 then rewrite(f);
  CLOSEFILE(F);
  Bitmap := TBitmap.Create;
  Bitmap.Width := 200;
  Bitmap.Height := 200;
  Image.Picture.Graphic := Bitmap;
  MaxZoom1.Enabled:=false;
  Zoomout.Enabled:=False;
  with dinosony do
  begin
       display:=panel1;
       panel1.show;
       filename:=dire+'\begin.avi';
       open;
  end;
  Panel1.visible:=false;
end;

procedure TForm2.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.Print1Click(Sender: TObject);
var
   x,y:Integer;
begin
    for x:=1 to 100 do
    for y:=1 to 100 do
        begin
        If Image.Canvas.pixels[x,y]=clBlack then
           with printer do
           begin
           beginDoc;
           Canvas.pixels[x,y]:=clblack;
           EndDoc;
           end;
        end;

end;

procedure TForm2.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    CurrentFile := OpenDialog1.FileName;
    Image.Picture.LoadFromFile(CurrentFile);
  end;
end;

procedure TForm2.Save1Click(Sender: TObject);
begin
  if CurrentFile <> '' then
    Image.Picture.SaveToFile(CurrentFile)
  else SaveAs1Click(Sender);
end;

procedure TForm2.Saveas1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    CurrentFile := SaveDialog1.FileName;
    Save1Click(Sender);
  end;
end;

procedure TForm2.New1Click(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  with NewBMPForm do
  begin
    ActiveControl := WidthEdit;
    WidthEdit.Text := IntToStr(Image.Picture.Graphic.Width);
    HeightEdit.Text := IntToStr(Image.Picture.Graphic.Height);
    if ShowModal <> idCancel then
    begin
      Bitmap := TBitmap.Create;
      Bitmap.Width := StrToInt(WidthEdit.Text);
      Bitmap.Height := StrToInt(HeightEdit.Text);
      Image.Picture.Graphic := Bitmap;
      CurrentFile := '';
    end;
  end;
end;

procedure TForm2.Copy1Click(Sender: TObject);
begin
  Clipboard.Assign(Image.Picture);
end;

procedure TForm2.Paste1Click(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  if Clipboard.HasFormat(CF_BITMAP) then
  begin
    Bitmap := TBitmap.Create;
    try
      Bitmap.Assign(Clipboard);
      Image.Canvas.Draw(0, 0, Bitmap);
    finally
      Bitmap.Free;
    end;
  end;
end;

procedure TForm2.Cut1Click(Sender: TObject);
var
  ARect: TRect;
begin
  Copy1Click(Sender);
  with Image.Canvas do
  begin
    CopyMode := cmWhiteness;
    ARect := Rect(0, 0, Image.Width, Image.Height);
    CopyRect(ARect, Image.Canvas, ARect);
    CopyMode := cmSrcCopy;
  end;
end;


procedure TForm2.bookClick(Sender: TObject);
type
    BookRec=Record
       FilN:String[12];
    end;
var
   MyList: TStringList;
   SearchRec:TSearchRec;
   BR:BookRec;
   BookF:File of BookRec;
   Check:Integer;
begin
     AssignFile(BookF,dire+'\bookfile.ps');
     Reset(BookF);
     CloseFile(bookF);
     with Form3 do
     begin
     showmodal;
     If ModalResult=mrOK then
        Image.Picture.loadfromfile(dire+'\pen\'+Label2.caption);
     End;
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
   Bitmap:Tbitmap;
begin
   if MessageDlg('Close the form?', mtConfirmation,
    [mbOk, mbCancel], 0) = mrCancel then
     CanClose := False
    Else
        begin
          Bitmap := TBitmap.Create;
          Bitmap.Width := 200;
          Bitmap.Height := 200;
          Image.Picture.Graphic := Bitmap;
          REWRITE(F);
          WRITE(F,'1');
          CLOSEFILE(F);
          with dinosony do
               begin
                    filename:=dire+'\begin.avi';
                    open;
               end;
          Canclose:=true;
        end;
end;

procedure TForm2.paintClick(Sender: TObject);
begin
     If paint.Down=true then
     begin
     image.cursor:=crMultiDrag;
     penButton.Enabled:=False;
     PenBar.Visible:=False;
     BrushButton.Enabled:=false;
     BrushBar.Visible:=true;
     end
     else
     If paint.Down=false then
     begin
     image.cursor:=crDefault;
     PenButton.Enabled:=true;
     PenBar.Visible:=PenButton.Down;
     BrushButton.Enabled:=true;
     BrushBar.Visible:=brushButton.Down;
     end;
end;

procedure TForm2.View1Click(Sender: TObject);
begin
     PenButton.Enabled:=False;
     BrushButton.Enabled:=False;
     Paint.Enabled:=False;
     MaxZoom1.Enabled:=true;
     Zoomin.Enabled:=true;
     image.visible:=false;
     image1.visible:=true;
     Image1.Picture.graphic:=image.picture.graphic;
     zoomout.enabled:=false;
     view1.enabled:=false;
end;

procedure TForm2.MaxZoom1Click(Sender: TObject);
begin
     PenButton.Enabled:=True;
     BrushButton.Enabled:=True;
     Paint.Enabled:=True;
     view1.Enabled:=True;
     Zoomout.enabled:=True;
     image1.visible:=false;
     image.visible:=true;
     MaxZoom1.Enabled:=false;
     Zoomin.Enabled:=False;
end;

procedure TForm2.About1Click(Sender: TObject);
begin
     Aboutbox.showmodal;
end;

procedure TForm2.dsou1Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\dinasor.wav';
          open;
          play;
     end;
end;

procedure TForm2.natrue2Click(Sender: TObject);
begin
   With dinosony do
     begin
          fileName:=dire+'\nature2.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature5Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature5.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature1Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature1.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature3Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature3.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature4Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature4.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature6Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature6.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature7Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature7.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature8Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature14.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature9Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature13.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature10Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature10.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature11Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature11.wav';
          open;
          play;
     end;

end;

procedure TForm2.nature12Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\nature12.wav';
          open;
          play;
     end;
end;


procedure TForm2.acesClick(Sender: TObject);
begin
     Panel1.visible:=true;
     with dinosony do
     begin
          filename:=dire+'\1_3.wav';
          open;
          wait:=true;
          play;
          filename:=dire+'\help.avi';
          display:=panel1;
          panel1.show;
          open;
          wait:=true;
          play;
     end;
     Panel1.visible:=false;
end;

procedure TForm2.dinsor2Click(Sender: TObject);
begin
     With dinosony do
     begin
          fileName:=dire+'\d2.wav';
          open;
          play;
     end;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
     If c then
     with dinosony do
     begin
       panel1.visible:=true;
       Wait:=true;
       play;
       panel1.visible:=false;
     End;
     c:=false;
end;

end.
